(* Computes Hecke matrices in raw format, i.e. with respect to different input
   and output bases, and prepares pari script to extract consistent description
   of eigenvalues 
*)
#include "heckehead.p"

; procedure calcraw
  (* E_\ell *)
  ; var
      i,s,a,b,c : integer
    ; extmat,cosrep,modsym : matrix3x3
  ; begin
      for s := 1 to dim do
      begin
        for i := 1 to params do raw[s,i] := 0
      ; ext3to3x3(orbit[param[freepar[s]]].x,extmat)
      ; for a := 0 to ell-1 do
        for b := 0 to ell-1 do
        begin
          make3x3(1,0,0,0,1,0,a*d,b,ell,cosrep)
        ; mult3x3(extmat,cosrep,modsym)
        ; addmodsymtorow(modsym,s)
        end
      ; for c := 0 to ell-1 do
        begin
          make3x3(1,0,0,c*d,ell,0,0,0,1,cosrep)
        ; mult3x3(extmat,cosrep,modsym)
        ; addmodsymtorow(modsym,s)
        end
      ; begin
          make3x3(ell,0,0,0,1,0,0,0,1,cosrep)
        ; mult3x3(extmat,cosrep,modsym)
        ; addmodsymtorow(modsym,s)
        end
      end
    end (* calcraw *)

; procedure cook
  ; var
      s,t,i : integer
  ; begin
      for s := 1 to dim do
      for t := 1 to dim do
      begin
        enum[s,t] := 0
      ; for i := 1 to params do
        enum[s,t] := enum[s,t]+raw[s,i]*soln[t,i]
      end
    end

; procedure getg 
  ; var
      s,t : integer
  ; begin
    ; for s := 1 to dim do
      for t := 1 to dim do
      enum[s,t]:=soln[t,freepar[s]]
    end

(**********************************************************************)
(*                                                                    *)
(*                       input/output routines                        *)
(*                                                                    *)
(**********************************************************************)

; procedure readsolnspace
  ; var
      ssf : text
    ; ssfname : varying [100] of char (* SUN Pascal *)
    ; i,s,d2,params2 : integer
  ; begin
      argv(2,ssfname) (* SUN Pascal *)
    ; reset(ssf,ssfname) (* SUN Pascal *)
    ; readln(ssf,d2)
    ; assert(d2=d) (* DELETE *)
    ; readln(ssf,params2)
    ; assert(params2=params) (* DELETE *)
    ; readln(ssf,dim)
    ; if dim>0 then
      begin
        for s := 1 to dim do read(ssf,freepar[s])
      ; for s := 1 to dim do
        begin
          for i := 1 to params do read(ssf,soln[s,i])
        ; readln(ssf)
        end
      end
    end

; procedure writemat
  ; var
      s,t : integer
  ; begin
    ; writeln('m=matrix(',dim,',',dim,',X,Y,read());')
    ; for s := 1 to dim do
      for t := 1 to dim do
      begin
        writeln(enum[t,s]:1) (* pari will read column by column *) 
      end
    end

; procedure writeinit
  ; begin
    ; writeln('\prompt=')
    ; writeln('\format=g0.3')
    ; writeln('\p')
    ; writeln('\p')
    ; writeln('\prompt=')
    ; writeln('print()')
    ; writeln('\prompt=d=')
    ; writeln('\prompt=')
    ; writeln(d:1,';')
    ; writeln('\a')
    ; writeln('\prompt=params=')
    ; writeln('\prompt=')
    ; writeln(params:1,':')
    ; writeln('\a')
    ; writeln('\prompt=dim=')
    ; writeln('\prompt=')
    ; writeln(dim:1,';')
    ; writeln('\a')
    ; writemat
    ; writeln('g=m^(-1);') (* The matrix that is needed to correct  
                              the solution matrix and the Hecke matrices. *)
    end

; procedure writeeig
  ; begin
    ; writeln(ell:0,';')
    ; writeln('\w eigen',d:1)
    ; writeln('he=m*g;')
    ; writeln('\r abii',d:1)
    ; writeln('ee=[1,0;0,1];')
    ; writeln('if(he==a*ee+b*ii,a*one+b*rho,error);')
    ; writeln('\w eigen',d:1)
    end

; begin
    readorbits
  ; make2tables
  ; makeparams
  ; readsolnspace
  ; getg
  ; writeinit
  ; while not eof do
    begin
      readln(ell)
    ; calcraw
    ; cook
    ; writemat
    ; writeeig
    end
  ; writeln('\q')
  end.
