(* Prepares pari script to extract an invariant subspace of the 
   solution space, based on a Hecke operator and a factor of its 
   characteristic polynomial.
*)

#include "heckehead.p"


(**********************************************************************)
(*                                                                    *)
(*                       input/output routines                        *)
(*                                                                    *)
(**********************************************************************)

; procedure readsolnspace
  ; var
      ssf : text
    ; ssfname : varying [100] of char (* SUN Pascal *)
    ; i,s : integer
  ; begin
      argv(2,ssfname) (* SUN Pascal *)
    ; reset(ssf,ssfname) (* SUN Pascal *)
    ; readln(ssf,d)
    ; readln(ssf,params)
    ; readln(ssf,dim)
    ; if dim>0 then
      begin
        for s := 1 to dim do read(ssf,freepar[s])
      ; for s := 1 to dim do
        begin
          for i := 1 to params do read(ssf,soln[s,i])
        ; readln(ssf)
        end
      end
    end

; procedure insertheckematrix (* transposed, actually *)
  ; var
      ssf : text
    ; ssfname : varying [100] of char (* SUN Pascal *)
    ; procedure siftrat{ Simple minded sifting of rationals.} 
      ; var
          ch:char;
          part_of_number:set of char;
      begin
        part_of_number:=['-','0'..'9','/']{I have removed '+'.} 
      ; ch:=ssf^
      ; while (not eof(ssf)) and not ( ch in part_of_number) do begin 
          get(ssf)
        ; ch:=ssf^
        end{while}
      ; if not eof(ssf) then
          begin
            repeat
            ; write(ch)
            ; get(ssf)
            ; ch:=ssf^
            until (eoln(ssf) or (not ( ch in part_of_number)))
            ; writeln
          end
      end{siftrat}
  ; begin
      ssfname:='hkmtrx'
    ; reset(ssf,ssfname) (* SUN Pascal *)
    ; writeln('m=matrix(',dim,',',dim,',X,Y,read());0;') 
    ; repeat
        siftrat
      until eof(ssf)
    end

; procedure writesolmat
  ; var
      s,t : integer
  ; begin
    ; writeln('dim=',dim:0,';')
    ; writeln('freeparold=vector(',dim,',X,read());0;')
    ; for s := 1 to dim do
      begin
        writeln(freepar[s]:1)
      end
    ; writeln('m=matrix(',params,',',dim,',X,Y,read());0;')
    ; for s := 1 to dim do
      for t := 1 to params do
      begin
        writeln(soln[s,t]:1) (* pari will read column by column *) 
      end
    ; for s := 1 to dim do
    end

; procedure writemat
  ; var
      s,t : integer
  ; begin
    ; writeln('m=matrix(',dim,',',dim,',X,Y,read());0;')
    ; for s := 1 to dim do
      for t := 1 to dim do
      begin
        writeln(enum[t,s]:1) (* pari will read column by column *) 
      end
    end

; procedure writeinit
  ; begin
    ; writeln('\prompt=')
    ; writeln('\format=g0.3')
    ; writeln('\p')
    ; writeln('\p')
    ; writeln('\prompt=')
    ; writeln('print()')
    ; writeln('\prompt=d=')
    ; writeln('\prompt=')
    ; writeln(d:1,';')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('\prompt=params=')
    ; writeln('\prompt=')
    ; writeln('params=',params:1,';')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('\prompt=olddim=')
    ; writeln('\prompt=')
    ; writeln(dim:1,';')
    ; writeln('\a')
    ; writesolmat
    ; writeln('sol=m;0;')
    ; writeln('m=matrix(dim,dim,X,Y,m[freeparold[X],Y]);0;\')
    ; writeln('sx=m^(-1);0;')
    ; writeln('den=denom(sx);')
    ; writeln('g=den*sx;0;')
    ; writeln('sol=sol*g;0;')
    ; insertheckematrix
    ; writeln('x=m~;0;')
    ; writeln('\r sbfctr')
    ; writeln('sx=%;0;')
    ; writeln('den=denom(sx);')
    ; writeln('sx=den*sx;0;')
    ; writeln('m=sol*keri(sx);0;')
    ; writeln('sol=m;0;')
    ; writeln('\prompt=newdim=')
    ; writeln('\prompt=')
    ; writeln('dim=matsize(m)[2];')
    ; writeln('\a')
    ; writeln('\w nwsl')
 ; writeln('m=matrix(params,dim,X,Y,lift(mod(sol[X,Y]+4500,224737))-4500);0;')
    ; writeln('myrows=indexrank(sol)[1];0;')
    ; writeln('until(pos<1,\')  (* This pari loop could be infinite *)
    ; writeln('try=matrix(matsize(myrows)[2],dim,X,Y,m[myrows[X],Y]);\')
    ; writeln('try=concat(try,224737*idmat(matsize(try)[1]));\')
    ; writeln('g=lllint(try);\')
    ; writeln('g=matrix(dim,dim,X,Y,g[X,Y]);\')
    ; writeln('try=m*g;\')
    ; writeln('pos=0;\')
    ; writeln('for(X=1,params,\')
    ; writeln('if(sum(0,Y=1,dim,lift(mod(try[X,Y]+4500,224737))>9000)>0,\')
    ; writeln('pos=X,));\')
    ; writeln('myrows=concat(myrows,[pos])\')
    ; writeln(')')
    ; writeln('m=matrix(params,dim,X,Y,lift(mod(try[X,Y]+4500,224737))-4500)')
    ; writeln('if(rank(m)==rank(concat(m,sol)),sol=m,)')
    ; writeln('freepar=indexrank(sol)[1];')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('sol~;')
    ; writeln('\a')
    ; writeln('\w nwsl')
    end


; begin
  ; readsolnspace
  ; writeinit
  ; writeln('\q')
  end.
